<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="fotosocial-user-register-dm">
  <template>
  </template>

  <script>
    /**
     * `fotosocial-user-register-dm`
     * data manager para registrar usuarios nuevos
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialUserRegisterDm extends Polymer.Element {
      static get is() { return 'fotosocial-user-register-dm'; }
      static get properties() {
        return {
          user: {
            type: Object,
            value: {}
          }
        };
      }

      saveUserLocalStorage() {
        let fotosocial = localStorage.getItem('fotosocial') ? JSON.parse(localStorage.getItem('fotosocial')) : false;
        if (fotosocial) {
          if (fotosocial.users.find(user => user.user === this.user.user)) {
            this.dispatchEvent(new CustomEvent('user-already-registered', {
              bubbles: true,
              composed: true,
              detail: this.user
            }));
          } else {
            fotosocial.users.push(this.user);
            localStorage.setItem('fotosocial', JSON.stringify(fotosocial));
            this.dispatchEvent(new CustomEvent('user-successfully-registered', {
              bubbles: true,
              composed: true,
              detail: this.user
            }));
          }
        } else {
          let newfotosocial = {
            users: [
              this.user
            ]
          } 
          localStorage.setItem('fotosocial', JSON.stringify(newfotosocial));
          this.dispatchEvent(new CustomEvent('user-successfully-registered', {
            bubbles: true,
            composed: true,
            detail: this.user
          }));
        }
      }
    }

    window.customElements.define(FotosocialUserRegisterDm.is, FotosocialUserRegisterDm);
  </script>
</dom-module>
